SystemOrganization addCategory: #'Announcements-Tests-Core'!

Announcement subclass: #AnnouncementMockA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!AnnouncementMockA commentStamp: 'Tbn 11/12/2010 10:54' prior: 0!
This is a simple test mock.!

Announcement subclass: #AnnouncementMockB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!AnnouncementMockB commentStamp: 'Tbn 11/12/2010 10:54' prior: 0!
This is a simple test mock!

AnnouncementMockB subclass: #AnnouncementMockC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!AnnouncementMockC commentStamp: 'Tbn 11/12/2010 10:54' prior: 0!
This is a simple test mock!

TestCase subclass: #AnnouncementSetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!AnnouncementSetTest methodsFor: 'testing' stamp: 'Tbn 11/12/2010 11:07'!
testIncludeOnlyOnce
	|set|
	set := AnnouncementMockA, AnnouncementMockB, AnnouncementMockA.
	self assert: set size = 2! !

!AnnouncementSetTest methodsFor: 'testing' stamp: 'Tbn 11/12/2010 11:06'!
testInstanceCreation
	|set|
	set := AnnouncementMockA, AnnouncementMockB.
	self assert: set size = 2! !

TestCase subclass: #AnnouncerTest
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Announcements-Tests-Core'!

!AnnouncerTest commentStamp: 'Tbn 11/12/2010 10:55' prior: 0!
An AnnouncerTest is a test class used to test Announcer.

Instance Variables
	announcer:		<Announcer>  the announcer to test

announcer
	- the announcer that is tested
!

!AnnouncerTest methodsFor: 'running' stamp: 'Tbn 11/12/2010 10:55'!
setUp
	"Set up the receiver before running a test"
	
	announcer := Announcer new! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:11'!
testAnnounceClass
	self assert: (announcer announce: AnnouncementMockA) 
		class = AnnouncementMockA! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:10'!
testAnnounceInstance
	| instance |
	instance := AnnouncementMockA new.
	self assert: (announcer announce: instance) = instance! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:08'!
testSubscribeBlock
	| announcement instance |
	announcer
		subscribe: AnnouncementMockA
		do: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockB.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:07'!
testSubscribeSend
	| announcement instance |
	announcer
		subscribe: AnnouncementMockA
		send: #value:
		to: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockB new.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:07'!
testSubscribeSet
	| announcement instance |
	announcer
		subscribe: AnnouncementMockA , AnnouncementMockC
		do: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockB.
	self assert: announcement isNil.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockC.
	self assert: announcement = instance! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 3/2/2009 10:06'!
testSubscribeSubclass
	| announcement instance |
	announcer
		subscribe: AnnouncementMockB
		do: [ :ann | announcement := ann ].
		
	announcement := nil.
	instance := announcer announce: AnnouncementMockA.
	self assert: announcement isNil.

	announcement := nil.
	instance := announcer announce: AnnouncementMockB.
	self assert: announcement = instance.
	
	announcement := nil.
	instance := announcer announce: AnnouncementMockC.
	self assert: announcement = instance.! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 9/25/2006 09:10'!
testUnsubscribeBlock
	| announcement |
	announcer
		subscribe: AnnouncementMockA
		do: [ :ann | announcement := ann ].
	announcer
		unsubscribe: self.

	announcement := nil.
	announcer announce: AnnouncementMockA new.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 9/25/2006 09:13'!
testUnsubscribeSend
	| announcement receiver |
	announcer
		subscribe: AnnouncementMockA
		send: #value:
		to: (receiver := [ :ann | announcement := ann ]).
	announcer
		unsubscribe: receiver.

	announcement := nil.
	announcer announce: AnnouncementMockA new.
	self assert: announcement isNil! !

!AnnouncerTest methodsFor: 'testing' stamp: 'lr 9/25/2006 09:13'!
testUnsubscribeSet
	| announcement |
	announcer
		subscribe: AnnouncementMockA , AnnouncementMockB
		do: [ :ann | announcement := ann ].
	announcer
		unsubscribe: self.

	announcement := nil.
	announcer announce: AnnouncementMockA new.
	self assert: announcement isNil.
	
	announcement := nil.
	announcer announce: AnnouncementMockB new.
	self assert: announcement isNil.! !
